bool enablePlugin = true;

void Render() {
    if (!enablePlugin || IsCam3Enabled() || GetApp().InputPort.InputsMode != 0) return;

    vec3[] enviSettings = GetEnviTextSettings();
    string speed = AdjustString(Math::Floor(GetVelocity().Length() * 3.6) + '');
    float scaler = enviSettings[3].x;
    bool enableBg = enviSettings[3].y == 1;

    if (Camera::IsBehind(ProjectVerticeSpace(VehicleState::GetVis(GetApp().GameScene, VehicleState::GetViewingPlayer()).AsyncState, enviSettings[0]))) return;

    if (enableBg) DrawSquare((vec3(AlineXAxis(enviSettings[0].x, speed) - (0.85 * scaler), enviSettings[0].y - (0.05 * scaler), enviSettings[0].z + 0.001)), vec3((1.185 * scaler), (0.795 * scaler), 0), enviSettings[2]);
    Numbers::DrawString(speed, vec3(AlineXAxis(enviSettings[0].x, speed), enviSettings[0].y, enviSettings[0].z), enviSettings[1], scaler);
}

void Main()
{
#if TMNEXT
    warn('This plugin does not support TM2020.');
    return;
#elif TURBO
    warn('This plugin does not support Turbo.');
    return;
#endif
}

void RenderMenu() {
    if(UI::MenuItem("\\$08f" + Icons::PlayCircleO + "\\$z Enable Real Speed", "", enablePlugin)) {
		enablePlugin = !enablePlugin;
	}
}

vec3[] GetEnviTextSettings() {
    string openEnvi = GetApp().RootMap.MapInfo.CollectionName;
    if (openEnvi == "Canyon") return {Setting_CanyonPos, Setting_TextColourCanyon, Setting_BgColourCanyon, vec3(Setting_CanyonSize, Setting_EnableBgCanyon ? 1 : 0, 0)};
    else if (openEnvi == "Valley") return {Setting_ValleyPos, Setting_TextColourValley, Setting_BgColourValley, vec3(Setting_ValleySize, Setting_EnableBgValley ? 1 : 0, 0)};
    else if (openEnvi == "Lagoon") return {Setting_LagoonPos, Setting_TextColourLagoon, Setting_BgColourLagoon, vec3(Setting_LagoonSize, Setting_EnableBgLagoon ? 1 : 0, 0)};
    else return {Setting_StadiumPos, Setting_TextColourStadium, Setting_BgColourStadium, vec3(Setting_StadiumSize, Setting_EnableBgStadium ? 1 : 0, 0)};
}

CTrackManiaPlayer@ GetPlayer() {
    if (GetApp().CurrentPlayground is null) {return null;}
    if (GetApp().CurrentPlayground.GameTerminals.Length == 0) {return null;}
    auto gameTerminal = cast<CTrackManiaGameTerminal@>(GetApp().CurrentPlayground.GameTerminals[0]);
    return cast<CTrackManiaPlayer@>(gameTerminal.ControlledPlayer);
}

float AlineXAxis(float center, const string &in speed) {
    if (speed.Length > 0) return (speed.Length * 0.03) + center;
    else return center;
}

string AdjustString(const string &in speed) {
    if (speed.Length == 1) return '00' + speed;
    else if (speed.Length == 2) return '0' + speed;
    else return speed;
}

bool IsCam3Enabled() {
    if (GetApp().Viewport.Cameras.Length < 2) return false;
    return GetApp().Viewport.Cameras[1].DofFocusZ == 10.000;
}

vec3 GetVelocity() {
    return VehicleState::GetVis(GetApp().GameScene, VehicleState::GetViewingPlayer()).AsyncState.WorldVel;
}